$(function(){
$("#responsive-box").dxResponsiveBox({
rows: [
{ ratio: 1 },
{ ratio: 2 },
{ ratio: 2, screen: "xs" },
{ ratio: 1 }
],
cols: [
{ ratio: 1 },
{ ratio: 2, screen: "lg" },
{ ratio: 1 }
],
singleColumnScreen: "sm",
screenByWidth: function(width) {
return ( width < 700 ) ? 'sm' : 'lg';
}
});
});
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" />
<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
<script>window.jQuery || document.write(decodeURIComponent('%3Cscript src="js/jquery.min.js"%3E%3C/script%3E'))</script>
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/20.2.6/css/dx.common.css" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/20.2.6/css/dx.light.css" />
<script src="https://cdn3.devexpress.com/jslib/20.2.6/js/dx.all.js"></script>
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="index.js"></script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="page">
<div id="responsive-box">
<div class="header" data-options="dxItem: {
location: [{
row: 0,
col: 0,
colspan: 3,
screen: 'lg'
}, {
row: 0,
col: 0,
colspan: 2,
screen: 'sm'
}]
}">
<p>Header</p>
</div>
<div class="content" data-options="dxItem: {
location: [{
row: 1,
col: 1,
screen: 'lg'
}, {
row: 1,
col: 0,
colspan: 2,
screen: 'sm'
}]
}">
<p>Content</p>
</div>
<div class="left-side-bar" data-options="dxItem: {
location: [{
row: 1,
col: 0,
screen: 'lg'
}, {
row: 2,
col: 0,
screen: 'sm'
}]
}">
<p>Left Bar</p>
</div>
<div class="right-side-bar" data-options="dxItem: {
location: [{
row: 1,
col: 2,
screen: 'lg'
}, {
row: 2,
col: 1,
screen: 'sm' }]
}">
<p>Right Bar</p>
</div>
<div class="footer" data-options="dxItem: {
location: [{
row: 2,
col: 0,
colspan: 3,
screen: 'lg'
}, {
row: 3,
col: 0,
colspan: 2,
screen: 'sm' }]
}">
<p>Footer</p>
</div>
</div>
</div>
</div>
</body>
</html>
.demo-container, #page{
height: 100%;
min-height: 300px;
}
#page .header {
background-color: rgba(243, 158, 108, 0.80);
text-align: center;
}
#page .content {
background-color: rgba(245, 229, 166, 0.80);
}
#page .left-side-bar {
background-color: rgba(148, 215, 199, 0.80);
}
#page .right-side-bar {
background-color: rgba(119, 199, 231, 0.80);
}
#page .footer {
background-color: rgba(123, 155, 207, 0.80);
}
.item {
height: 100%;
}
#page p {
font-size: 20px;
padding-top: 10px;
text-align: center;
}

import React from 'react';
import ResponsiveBox, {
Row,
Col,
Item,
Location,
} from 'devextreme-react/responsive-box';
function screen(width) {
return (width < 700) ? 'sm' : 'lg';
}
class App extends React.Component {
render() {
return (
<div id="page">
<ResponsiveBox
singleColumnScreen="sm"
screenByWidth={screen}>
<Row ratio={1}></Row>
<Row ratio={2}></Row>
<Row ratio={1}></Row>
<Col ratio={1}></Col>
<Col ratio={2} screen="lg"></Col>
<Col ratio={1}></Col>
<Item>
<Location
row={0}
col={0}
colspan={3}
screen="lg"
></Location>
<Location
row={0}
col={0}
colspan={2}
screen="sm"
></Location>
<div className="header item">
<p>Header</p>
</div>
</Item>
<Item>
<Location
row={1}
col={1}
screen="lg"
></Location>
<Location
row={1}
col={0}
colspan={2}
screen="sm"
></Location>
<div className="content item">
<p>Content</p>
</div>
</Item>
<Item>
<Location
row={1}
col={0}
screen="lg"
></Location>
<Location
row={2}
col={0}
screen="sm"
></Location>
<div className="left-side-bar item">
<p>Left Bar</p>
</div>
</Item>
<Item>
<Location
row={1}
col={2}
screen="lg"
></Location>
<Location
row={2}
col={1}
screen="sm"
></Location>
<div className="right-side-bar item">
<p>Right Bar</p>
</div>
</Item>
<Item>
<Location
row={2}
col={0}
colspan={3}
screen="lg"
></Location>
<Location
row={3}
col={0}
colspan={2}
screen="sm"
></Location>
<div className="footer item">
<p>Footer</p>
</div>
</Item>
</ResponsiveBox>
</div>
);
}
}
export default App;
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.js';
ReactDOM.render(
<App />,
document.getElementById('app'),
);
<!DOCTYPE html>
<html>
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/22.2.5/css/dx.light.css" />
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="https://unpkg.com/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://unpkg.com/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.js");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"></div>
</div>
</body>
</html>
.demo-container,
#page,
#app {
height: 100%;
min-height: 300px;
}
.header {
background-color: rgba(243, 158, 108, 0.8);
text-align: center;
}
.content {
background-color: rgba(245, 229, 166, 0.8);
}
.left-side-bar {
background-color: rgba(148, 215, 199, 0.8);
}
.right-side-bar {
background-color: rgba(119, 199, 231, 0.8);
}
.footer {
background-color: rgba(123, 155, 207, 0.8);
}
.item {
height: 100%;
}
#page p {
font-size: 20px;
padding-top: 10px;
text-align: center;
}
window.config = {
transpiler: 'plugin-babel',
meta: {
'devextreme/localization.js': {
'esModule': true,
},
},
paths: {
'npm:': 'https://unpkg.com/',
},
defaultExtension: 'js',
map: {
'react': 'npm:react@17.0.2/umd/react.development.js',
'react-dom': 'npm:react-dom@17.0.2/umd/react-dom.development.js',
'prop-types': 'npm:prop-types@15.8.1/prop-types.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@1.28.0/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign@1.1.0',
'devextreme': 'npm:devextreme@22.2.5/cjs',
'devextreme-react': 'npm:devextreme-react@22.2.5',
'jszip': 'npm:jszip@3.7.1/dist/jszip.min.js',
'devextreme-quill': 'npm:devextreme-quill@1.5.20/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.1.72/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.42/dist/dx-gantt.js',
'@devextreme/runtime': 'npm:@devextreme/runtime@3.0.11',
'inferno': 'npm:inferno@7.4.11/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@7.4.11/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate@7.4.11/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
// SystemJS plugins
'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.4/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.4/parser-html.js',
},
packages: {
'devextreme': {
defaultExtension: 'js',
},
'devextreme-react': {
main: 'index.js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:@devextreme/runtime@3.0.11/inferno/package.json',
],
babelOptions: {
sourceMaps: false,
stage0: true,
react: true,
},
};
System.config(window.config);

<template>
<div id="page">
<DxResponsiveBox
:screen-by-width="screen"
single-column-screen="sm"
>
<DxRow :ratio="1"/>
<DxRow
:ratio="2"
screen="xs"
/>
<DxRow :ratio="2"/>
<DxRow :ratio="1"/>
<DxCol :ratio="1"/>
<DxCol
:ratio="2"
screen="lg"
/>
<DxCol :ratio="1"/>
<DxItem>
<DxLocation
:row="0"
:col="0"
:colspan="3"
screen="lg"
/>
<DxLocation
:row="0"
:col="0"
:colspan="2"
screen="sm"
/>
<div class="header item">
<p>Header</p>
</div>
</DxItem>
<DxItem>
<DxLocation
:row="1"
:col="1"
screen="lg"
/>
<DxLocation
:row="1"
:col="0"
:colspan="2"
screen="sm"
/>
<div class="content item">
<p>Content</p>
</div>
</DxItem>
<DxItem>
<DxLocation
:row="1"
:col="0"
screen="lg"
/>
<DxLocation
:row="2"
:col="0"
screen="sm"
/>
<div class="left-side-bar item">
<p>Left Bar</p>
</div>
</DxItem>
<DxItem>
<DxLocation
:row="1"
:col="2"
screen="lg"
/>
<DxLocation
:row="2"
:col="1"
screen="sm"
/>
<div class="right-side-bar item">
<p>Right Bar</p>
</div>
</DxItem>
<DxItem>
<DxLocation
:row="2"
:col="0"
:colspan="3"
screen="lg"
/>
<DxLocation
:row="3"
:col="0"
:colspan="2"
screen="sm"
/>
<div class="footer item">
<p>Footer</p>
</div>
</DxItem>
</DxResponsiveBox>
</div>
</template>
<script>
import { DxResponsiveBox, DxItem, DxLocation, DxCol, DxRow } from 'devextreme-vue/responsive-box';
export default {
components: {
DxResponsiveBox,
DxItem,
DxLocation,
DxCol,
DxRow
},
data() {
return {
screen(width) {
return (width < 700) ? 'sm' : 'lg';
}
};
}
};
</script>
<style>
.demo-container, #page{
height: 100%;
min-height: 300px;
}
.header {
background-color: rgba(243, 158, 108, 0.80);
text-align: center;
}
.content {
background-color: rgba(245, 229, 166, 0.80);
}
.left-side-bar {
background-color: rgba(148, 215, 199, 0.80);
}
.right-side-bar {
background-color: rgba(119, 199, 231, 0.80);
}
.footer {
background-color: rgba(123, 155, 207, 0.80);
}
.item {
height: 100%;
}
#page p {
font-size: 20px;
padding-top: 10px;
text-align: center;
}
</style>
import { createApp } from 'vue';
import App from './App.vue';
createApp(App).mount('#app');
<!DOCTYPE html>
<html>
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/20.2.6/css/dx.common.css" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/20.2.6/css/dx.light.css" />
<script src="https://unpkg.com/core-js@2.4.1/client/shim.min.js"></script>
<script src="https://unpkg.com/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import('./index.js');
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app">
</div>
</div>
</body>
</html>
System.config({
transpiler: 'plugin-babel',
meta: {
'*.vue': {
loader: 'vue-loader'
},
'devextreme/localization.js': {
"esModule": true
},
},
paths: {
'npm:': 'https://unpkg.com/'
},
map: {
'vue': 'npm:vue@3.0.0/dist/vue.esm-browser.js',
'vue-loader': 'npm:dx-systemjs-vue-browser@1.0.15/index.js',
'mitt': 'npm:mitt/dist/mitt.umd.js',
'rrule': 'npm:rrule@2.6.6/dist/es5/rrule.js',
'luxon': 'npm:luxon@1.26.0/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign@1.1.0',
'devextreme': 'npm:devextreme@20.2.6',
'devextreme-vue': 'npm:devextreme-vue@20.2.6',
'jszip': 'npm:jszip@3.6.0/dist/jszip.min.js',
'devextreme-quill': 'npm:devextreme-quill@0.10.3/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.0.18/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@2.0.24/dist/dx-gantt.js',
'preact': 'npm:preact@10.5.13/dist/preact.js',
'preact/hooks': 'npm:preact@10.5.13/hooks/dist/hooks.js',
'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js'
},
packages: {
'devextreme-vue': {
main: 'index.js'
},
'devextreme': {
defaultExtension: 'js'
},
'devextreme/events/utils': {
main: 'index'
},
'devextreme/events': {
main: 'index'
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js'
}
},
babelOptions: {
sourceMaps: false,
stage0: true
}
});

<div id="page">
<dx-responsive-box singleColumnScreen="sm" [(screenByWidth)]="screen">
<dxi-row [ratio]="1"></dxi-row>
<dxi-row [ratio]="2"></dxi-row>
<dxi-row [ratio]="1"></dxi-row>
<dxi-col [ratio]="1"></dxi-col>
<dxi-col [ratio]="2" screen="lg"></dxi-col>
<dxi-col [ratio]="1"></dxi-col>
<dxi-item>
<dxi-location
[row]="0"
[col]="0"
[colspan]="3"
screen="lg"
></dxi-location>
<dxi-location
[row]="0"
[col]="0"
[colspan]="2"
screen="sm"
></dxi-location>
<div *dxTemplate class="header item">
<p>Header</p>
</div>
</dxi-item>
<dxi-item>
<dxi-location [row]="1" [col]="1" screen="lg"></dxi-location>
<dxi-location
[row]="1"
[col]="0"
[colspan]="2"
screen="sm"
></dxi-location>
<div *dxTemplate class="content item">
<p>Content</p>
</div>
</dxi-item>
<dxi-item>
<dxi-location [row]="1" [col]="0" screen="lg"></dxi-location>
<dxi-location [row]="2" [col]="0" screen="sm"></dxi-location>
<div *dxTemplate class="left-side-bar item">
<p>Left Bar</p>
</div>
</dxi-item>
<dxi-item>
<dxi-location [row]="1" [col]="2" screen="lg"></dxi-location>
<dxi-location [row]="2" [col]="1" screen="sm"></dxi-location>
<div *dxTemplate class="right-side-bar item">
<p>Right Bar</p>
</div>
</dxi-item>
<dxi-item>
<dxi-location
[row]="2"
[col]="0"
[colspan]="3"
screen="lg"
></dxi-location>
<dxi-location
[row]="3"
[col]="0"
[colspan]="2"
screen="sm"
></dxi-location>
<div *dxTemplate class="footer item">
<p>Footer</p>
</div>
</dxi-item>
</dx-responsive-box>
</div>
import { NgModule, Component, enableProdMode } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import { DxResponsiveBoxModule } from 'devextreme-angular';
if (!/localhost/.test(document.location.host)) {
enableProdMode();
}
@Component({
selector: 'demo-app',
templateUrl: 'app/app.component.html',
styleUrls: ['app/app.component.css'],
})
export class AppComponent {
screen(width) {
return (width < 700) ? 'sm' : 'lg';
}
}
@NgModule({
imports: [
BrowserModule,
DxResponsiveBoxModule,
],
declarations: [AppComponent],
bootstrap: [AppComponent],
})
export class AppModule { }
platformBrowserDynamic().bootstrapModule(AppModule);
::ng-deep .demo-container,
#page {
height: 100%;
min-height: 300px;
}
::ng-deep #page .header {
background-color: rgba(243, 158, 108, 0.8);
text-align: center;
}
::ng-deep #page .content {
background-color: rgba(245, 229, 166, 0.8);
}
::ng-deep #page .left-side-bar {
background-color: rgba(148, 215, 199, 0.8);
}
::ng-deep #page .right-side-bar {
background-color: rgba(119, 199, 231, 0.8);
}
::ng-deep #page .footer {
background-color: rgba(123, 155, 207, 0.8);
}
::ng-deep .item {
height: 100%;
}
::ng-deep #page p {
font-size: 20px;
padding-top: 10px;
text-align: center;
}
// In real applications, you should not transpile code in the browser.
// You can see how to create your own application with Angular and DevExtreme here:
// https://js.devexpress.com/Documentation/Guide/Angular_Components/Getting_Started/Create_a_DevExtreme_Application/
window.config = {
transpiler: 'ts',
typescriptOptions: {
module: 'system',
emitDecoratorMetadata: true,
experimentalDecorators: true,
},
meta: {
'typescript': {
'exports': 'ts',
},
'devextreme/localization.js': {
'esModule': true,
},
},
paths: {
'npm:': 'https://unpkg.com/',
},
map: {
'ts': 'npm:plugin-typescript@4.2.4/lib/plugin.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'@angular/core': 'npm:@angular/core@12.2.16',
'@angular/platform-browser': 'npm:@angular/platform-browser@12.2.16',
'@angular/platform-browser-dynamic': 'npm:@angular/platform-browser-dynamic@12.2.16',
'@angular/forms': 'npm:@angular/forms@12.2.16',
'@angular/common': 'npm:@angular/common@12.2.16',
'@angular/compiler': 'npm:@angular/compiler@12.2.16',
'tslib': 'npm:tslib@2.3.1/tslib.js',
'rxjs': 'npm:rxjs@7.5.3/dist/bundles/rxjs.umd.js',
'rxjs/operators': 'npm:rxjs@7.5.3/dist/cjs/operators/index.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@1.28.0/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign@1.1.0',
'devextreme': 'npm:devextreme@22.2.3/cjs',
'devextreme/bundles/dx.all': 'npm:devextreme@22.2.3/bundles/dx.all.js',
'jszip': 'npm:jszip@3.7.1/dist/jszip.min.js',
'devextreme-quill': 'npm:devextreme-quill@1.5.18/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.1.65',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.37',
'devextreme-angular': 'npm:devextreme-angular@22.2.3',
'@devextreme/runtime': 'npm:@devextreme/runtime@3.0.11',
'inferno': 'npm:inferno@7.4.11/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat@7.4.11/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@7.4.11/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate@7.4.11/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode@7.4.11/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class@7.4.11/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras@7.4.11/dist/inferno-extras.min.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.7.1/standalone.js',
'prettier/parser-html': 'npm:prettier@2.7.1/parser-html.js',
},
packages: {
'app': {
main: './app.component.ts',
defaultExtension: 'ts',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
'rxjs': {
defaultExtension: 'js',
},
'rxjs/operators': {
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:@devextreme/runtime@3.0.11/inferno/package.json',
'npm:@angular/*/package.json',
'npm:@angular/common@12.2.16/*/package.json',
'npm:rxjs@7.5.3/package.json',
'npm:rxjs@7.5.3/operators/package.json',
'npm:devextreme-angular@22.2.3/*/package.json',
'npm:devextreme-angular@22.2.3/ui/*/package.json',
'npm:devextreme-angular@22.2.3/package.json',
'npm:devexpress-diagram@2.1.65/package.json',
'npm:devexpress-gantt@4.1.37/package.json',
],
};
System.config(window.config);
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/22.2.3/css/dx.light.css" />
<script src="https://unpkg.com/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://unpkg.com/zone.js@0.12.0/dist/zone.js"></script>
<script src="https://unpkg.com/reflect-metadata@0.1.13/Reflect.js"></script>
<script src="https://unpkg.com/systemjs@0.21.3/dist/system.js"></script>
<script src="config.js"></script>
<script>
System.import("app").catch(console.error.bind(console));
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<demo-app>Loading...</demo-app>
</div>
</body>
</html>